/*
 * collage.c
 *
 *  For Giuliana's book cover, e.g.
 *
 */

#include "string.h"
#include "allheaders.h"

l_int32 main(int    argc,
             char **argv)
{
char       buf[512], buf2[512], cmd[512];
l_int32    i, j, w, h, xmt, wmt, hmt, fullwidth, npairs, hd, skip, space;
l_int32    iconsize, nx, ny, pagew, pageh, val, ret, fullwidth_even, xoff;
l_float32  fract;
PIX       *pix, *pix1, *pix2, *pix3, *pix4, *pixt, *pixs, *pixg, *pixd;
PIXA      *pixas, *pixad;

    iconsize = 75;
    space = 20;
//    nx = 24;
//    ny = 32;
    nx = 16;
    ny = 22;
    pagew = nx * iconsize;
    pageh = ny * iconsize;
    pixas = pixaCreate(20);
    for (i = 1; i <= 24; i++) {
        snprintf(buf, sizeof(buf), "icon%d.png", i);
        pix = pixRead(buf);
        pix1 = pixScaleToSize(pix, iconsize, iconsize);
        pixaAddPix(pixas, pix1, L_INSERT);
        pixDestroy(&pix);
    }
    pixad = pixaCreate(0);
    for (i = 0; i < ny; i++) {
        for (j = 0; j < nx; j++) {
            genRandomIntegerInRange(24, 0, &val);
            pix = pixaGetPix(pixas, val, L_COPY);
            pixaAddPix(pixad, pix, L_INSERT);
        }
    }
    pixt = pixaDisplayTiled(pixad, pagew, 0, 0);
    pixGetDimensions(pixt, &w, &h, NULL);
    pix = pixRead("mondayteller.png");
    pixs = pixScaleToSize(pix, 4 * iconsize, 5 * iconsize);
    pixDestroy(&pix);
    pixg = pixCreate(w, h, 8);
    pixSetAll(pixg);
    for (i = 0; i < 4; i++) {
        fract = 0.2 * i;
        pixd = pixFadeWithGray(pixt, pixg, fract, L_BLEND_TO_WHITE);
        pixRasterop(pixd, ((nx - 4) / 2) * iconsize, ((ny - 6) / 2) * iconsize,
                    4 * iconsize, 5 * iconsize, PIX_SRC, pixs, 0, 0);
        snprintf(buf, sizeof(buf), "/tmp/collage.%d.png",
                 (l_int32)(10.0 * fract));
        pixWrite(buf, pixd, IFF_PNG);
        if (i == 1) {
            pixt = pixScale(pixd, 1.0, 1.0);
            pixWrite("junkcollage.png", pixt, IFF_PNG);
            pixDestroy(&pixt);
        }
        pixDestroy(&pixd);
    }
    convertFilesToPdf("/tmp", "collage.", 150, 1.0, 3, 90, "Collages",
                      "collage.pdf");

    // Make special strips
    pixaDestroy(&pixad);
    pix1 = pixRead("mondayteller.png");
    pix2 = pixScaleToSize(pix1, 1.6 * iconsize, 2.0 * iconsize);
    pixGetDimensions(pix2, &wmt, &hmt, NULL);
    fullwidth = 10 * iconsize + 9 * space;
    fullwidth_even = 2 * 1.6 * iconsize + 8 * iconsize + 9 * space;
    for (i = 1; i <= 10; i++) {
        if (i % 2 == 1) {  // odd
            pixd = pixCreate(fullwidth, hmt, 32);
            pixSetAll(pixd);
            xmt = (fullwidth - wmt) / 2;
            pixRasterop(pixd, xmt, 0, wmt, hmt, PIX_SRC, pix2, 0, 0);
            npairs = (i - 1) / 2;
            if (i > 1) skip = (2 * xmt / (i - 1) - iconsize);
            for (j = 0; j < npairs; j++) {
                genRandomIntegerInRange(24, 0, &val);
                pix3 = pixaGetPix(pixas, val, L_COPY);
                genRandomIntegerInRange(24, 0, &val);
                pix4 = pixaGetPix(pixas, val, L_COPY);
                pixRasterop(pixd, j * (iconsize + skip), hmt - iconsize,
                            iconsize, iconsize, PIX_SRC, pix3, 0, 0);
                pixRasterop(pixd,
                            fullwidth - iconsize - j * (iconsize + skip),
                            hmt - iconsize,
                            iconsize, iconsize, PIX_SRC, pix4, 0, 0);
                pixDestroy(&pix3);
                pixDestroy(&pix4);
            }
            pixDisplay(pixd, 100, 100);
            snprintf(buf, sizeof(buf), "/tmp/stripcoll.%d.png", i);
            pixWrite(buf, pixd, IFF_PNG);
            snprintf(buf2, sizeof(buf2), "/tmp/stripcoll.%d.ps", i);
            snprintf(cmd, sizeof(cmd), "converttops %s %s", buf, buf2);
            ret = system(cmd);
            pixDestroy(&pixd);
        }
        else {  // even
            pixd = pixCreate(fullwidth_even, hmt, 32);
            pixSetAll(pixd);
            npairs = i / 2;
            skip = (fullwidth_even - 2 * wmt - (i - 2) * iconsize) / (i - 1);
            fprintf(stderr, "skip[%d] = %d\n", i, skip);
            pixRasterop(pixd, 0, 0, wmt, hmt, PIX_SRC, pix2, 0, 0);
            pixRasterop(pixd, fullwidth_even - wmt, 0, wmt, hmt, PIX_SRC,
                        pix2, 0, 0);
            xoff = wmt + skip;
            for (j = 2; j <= npairs; j++) {
                genRandomIntegerInRange(24, 0, &val);
                pix3 = pixaGetPix(pixas, val, L_COPY);
                genRandomIntegerInRange(24, 0, &val);
                pix4 = pixaGetPix(pixas, val, L_COPY);
                pixRasterop(pixd, xoff + (j - 2) * (iconsize + skip),
                            hmt - iconsize, iconsize, iconsize,
                            PIX_SRC, pix3, 0, 0);
                pixRasterop(pixd,
                            fullwidth_even - wmt - (j - 1) * (iconsize + skip),
                            hmt - iconsize, iconsize, iconsize,
                            PIX_SRC, pix4, 0, 0);
                pixDestroy(&pix3);
                pixDestroy(&pix4);
            }
            pixDisplay(pixd, 100, 100);
            snprintf(buf, sizeof(buf), "/tmp/stripcoll.%d.png", i);
            pixWrite(buf, pixd, IFF_PNG);
            snprintf(buf2, sizeof(buf2), "/tmp/stripcoll.%d.ps", i);
            snprintf(cmd, sizeof(cmd), "converttops %s %s", buf, buf2);
            ret = system(cmd);
            pixDestroy(&pixd);
        }
    }


#if 0
    // Make uniform strips
    pixaDestroy(&pixad);
    for (i = 0; i < 10; i++) {
        pixad = pixaCreate(nx);
        for (j = 0; j < nx; j++) {
            genRandomIntegerInRange(24, 0, &val);
            pix = pixaGetPix(pixas, val, L_COPY);
            pixaAddPix(pixad, pix, L_INSERT);
        }
        pixt = pixaDisplayTiled(pixad, pagew, 0, 0);
        snprintf(buf, sizeof(buf), "/tmp/stripcollage.%d.png", i);
        pixWrite(buf, pixt, IFF_PNG);
        pixaDestroy(&pixad);
        pixDestroy(&pixt);
    }
#endif

    return 0;
}
