/*
 * recogsort.c
 */

#include "string.h"
#include "unistd.h"
#include "allheaders.h"


l_int32 main(int    argc,
             char **argv)
{
char      *boxatxt;
l_int32    i;
BOX       *box, *box1, *box2;
BOXA      *boxa, *boxa1, *boxa2, *boxa3;
BOXAA     *baa, *baa1;
NUMAA     *naa1;
PIX       *pixdb, *pix, *pix1, *pix2, *pix3, *pix4;
PIXA      *pixa, *pixa1, *pixa2, *pixa3, *pixat;
L_RECOG   *recog;
L_RECOGA  *recoga;
SARRAY    *sa1;

    PROCNAME("recogsort");

    /* ----- Example identifying samples using training data ----- */
#if 1
        /* Read the training data */
    pixat = pixaRead("train06.pa");
    recog = recogCreateFromPixa(pixat, 0, 0, L_USE_ALL, 128, 1, "fonts");
    recoga = recogaCreateFromRecog(recog);
    pixaDestroy(&pixat);

        /* Read the data from all samples */
    pix1 = pixRead("samples06.png");
    boxatxt = pixGetText(pix1);
    boxa1 = boxaReadMem((l_uint8 *)boxatxt, strlen(boxatxt));
    pixa1 = pixaCreateFromBoxa(pix1, boxa1, NULL);
    pixDestroy(&pix1);  /* destroys boxa1 */

        /* Identify components in the sample data */
    pixa2 = pixaCreate(0);
    for (i = 0; i < 9; i++) {
//        if (i != 4) continue;
        pix1 = pixaGetPix(pixa1, i, L_CLONE);

            /* Show the 2d box data in the sample */
        boxa2 = pixConnComp(pix1, NULL, 8);
        baa = boxaSort2d(boxa2, NULL, 6, 6, 5);
        pix2 = boxaaDisplay(baa, 3, 1, 0xff000000, 0x00ff0000, 0, 0);
        boxaaDestroy(&baa);
        boxaDestroy(&boxa2);
        pixDisplay(pix2, 100 * i, 500);
        pixDestroy(&pix2);

            /* Get the numbers in the sample */
        recogaIdentifyMultiple(recoga, pix1, 0, 0, &boxa3, NULL, &pixdb, 0);
        sa1 = recogaExtractNumbers(recoga, boxa3, 0.65, 10, &baa1, &naa1);
        sarrayWriteStream(stderr, sa1);
        boxaaWriteStream(stderr, baa1);
        numaaWriteStream(stderr, naa1);
        pixaAddPix(pixa2, pixdb, L_INSERT);
//        pixaWrite("/tmp/pixa.pa", pixa2);
        pixDestroy(&pix1);
        boxaDestroy(&boxa3);
        boxaaDestroy(&baa1);
        numaaDestroy(&naa1);
        sarrayDestroy(&sa1);
    }

    pix3 = pixaDisplayLinearly(pixa2, L_VERT, 1.0, 0, 20, 1, NULL);
    pixWrite("/tmp/pix3.png", pix3, IFF_PNG);
    pixaDestroy(&pixa2);
    pixDestroy(&pix1);
    pixDestroy(&pix3);
    pixaDestroy(&pixa1);
    boxaDestroy(&boxa1);
    recogaDestroy(&recoga);
#endif

    /* ----- Generating sample data in a single pix from cleans ----- */
#if 0
    pixa1 = pixaCreate(0);
    pix1 = pixRead("sample06.69.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.79.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.89.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.343.jpg");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.355.jpg");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.471.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.499.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.505.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    pix1 = pixRead("sample06.44.png");
    pixaAddPix(pixa1, pix1, L_INSERT);
    boxa1 = boxaCreate(0);
    box = boxCreate(1012, 94, 306, 304);  /* with 69 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(987, 108, 305, 304);  /* with 79 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(1010, 100, 306, 304);  /* with 89 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(1092, 92, 308, 303);  /* with 343 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(1098, 92, 304, 303);  /* with 355 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(1059, 144, 305, 304);  /* with 471 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(1094, 126, 302, 303);  /* with 499 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(1078, 118, 304, 304);  /* with 505 */
    boxaAddBox(boxa1, box, L_INSERT);
    box = boxCreate(192, 96, 306, 304);  /* with 44 */
    boxaAddBox(boxa1, box, L_INSERT);
    pixa2 = pixaCreate(0);
    for (i = 0; i < 9; i++) {
        pix1 = pixaGetPix(pixa1, i, L_CLONE);
        box = boxaGetBox(boxa1, i, L_CLONE);
        pix2 = pixConvertTo1(pix1, 128);
        pix3 = pixClipRectangle(pix2, box, NULL);
        pixaAddPix(pixa2, pix3, L_INSERT);
        pixDestroy(&pix1);
        pixDestroy(&pix2);
        boxDestroy(&box);
    }
    pix4 = pixaDisplayTiledInRows(pixa2, 1, 2000, 1.0, 0, 25, 2);
    pixWrite("/tmp/samples06.png", pix4, IFF_PNG);
    pixDestroy(&pix4);
    pixaDestroy(&pixa1);
    pixaDestroy(&pixa2);
#endif

#if 0
    pixa = pixaCreate(0);
    pix1 = pixRead("sample06.69.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.79.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.89.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.343.jpg");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.355.jpg");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.471.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.499.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.505.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    pix1 = pixRead("sample06.44.png");
    pixaAddPix(pixa, pix1, L_INSERT);
    boxa = boxaCreate(0);
    box = boxCreate(1012, 94, 306, 304);  /* with 69 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(987, 108, 305, 304);  /* with 79 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(1010, 100, 306, 304);  /* with 89 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(1092, 92, 308, 303);  /* with 343 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(1098, 92, 304, 303);  /* with 355 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(1059, 144, 305, 304);  /* with 471 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(1094, 126, 302, 303);  /* with 499 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(1078, 118, 304, 304);  /* with 505 */
    boxaAddBox(boxa, box, L_INSERT);
    box = boxCreate(192, 96, 306, 304);  /* with 44 */
    boxaAddBox(boxa, box, L_INSERT);
    pixat = pixaRead("train06.pa");
    recog = recogCreateFromPixa(pixat, 0, 0, L_USE_ALL, 128, 1, "fonts");
    recoga = recogaCreateFromRecog(recog);
    pixa2 = pixaCreate(0);
    pixa3 = pixaCreate(0);
    for (i = 0; i < 9; i++) {
//        if (i != 4) continue;
        pix1 = pixaGetPix(pixa, i, L_CLONE);
        box = boxaGetBox(boxa, i, L_CLONE);
        pix2 = pixConvertTo1(pix1, 128);
        pix3 = pixClipRectangle(pix2, box, NULL);
        pixaAddPix(pixa3, pix3, L_INSERT);
//        pixDisplay(pix3, 100 * i, 100);
        boxa2 = pixConnComp(pix3, NULL, 8);
        baa = boxaSort2d(boxa2, NULL, 6, 6, 5);
        pix4 = boxaaDisplay(baa, 3, 1, 0xff000000, 0x00ff0000, 0, 0);
        boxaaDestroy(&baa);
        boxaDestroy(&boxa2);
        pixDisplay(pix4, 100 * i, 500);
        recogaIdentifyMultiple(recoga, pix3, 0, 0, &boxa1, &pixa1, &pixdb, 0);
        sa1 = recogaExtractNumbers(recoga, boxa1, 0.65, 10, &baa1, &naa1);
        sarrayWriteStream(stderr, sa1);
        boxaaWriteStream(stderr, baa1);
        numaaWriteStream(stderr, naa1);
        pixaAddPix(pixa2, pixdb, L_INSERT);
        pixaWrite("/tmp/pixa.pa", pixa1);
        pixDestroy(&pix1);
        pixDestroy(&pix2);
        pixDestroy(&pix4);
        boxDestroy(&box);
        boxaDestroy(&boxa1);
        pixaDestroy(&pixa1);
        boxaaDestroy(&baa1);
        numaaDestroy(&naa1);
        sarrayDestroy(&sa1);
    }

    pix1 = pixaDisplayTiledInRows(pixa3, 1, 2000, 1.0, 0, 25, 2);
    pixWrite("/tmp/samples06.png", pix1, IFF_PNG);
    pix2 = pixaDisplayLinearly(pixa2, L_VERT, 1.0, 0, 20, 1, NULL);
    pixWrite("/tmp/pix2.png", pix2, IFF_PNG);
    pixaDestroy(&pixa2);
    pixDestroy(&pix1);
    pixDestroy(&pix2);
    pixaDestroy(&pixa);
    pixaDestroy(&pixa3);
    boxaDestroy(&boxa);
    pixaDestroy(&pixat);
    recogaDestroy(&recoga);
#endif

#if 0
    pix1 = pixRead("sample06.69.png");
    pix2 = pixConvertTo1(pix1, 128);
    box = boxCreate(1012, 94, 306, 304);
    pix3 = pixClipRectangle(pix2, box, NULL);
    pixDisplay(pix3, 100, 100);
    boxa = pixConnComp(pix3, &pixa, 8);
    baa = boxaSort2d(boxa, NULL, 6, 6, 5);
    pix4 = boxaaDisplay(baa, 3, 1, 0xff000000, 0x00ff0000, 0, 0);
    pixDisplay(pix4, 0, 500);
#endif

}


